(define-module (zola)
  #:use-module (gnu packages)
  #:use-module (gnu packages base)
  #:use-module (gnu packages compression)
  #:use-module (gnu services)
  #:use-module (guix utils)
  #:use-module (guix gexp)
  #:use-module (guix packages)
  #:use-module (guix git-download)
  #:use-module (guix build-system cargo)
  #:use-module ((guix licenses) #:prefix license:))

(define-public zola
  (let ((commit "8dd1b30594dcfa5344ba36b6b057a5b0aa9bd277")
        (revision "0"))
    (package
      (name "zola")
      (version "0.17.2")
      (source (origin
                (method git-fetch)
                (uri (git-reference
                      (url "https://github.com/getzola/zola.git")
                      (commit commit)))
                (sha256
                 (base32
                  "11ynfizxgfm0dy8i4s0dfws4g9chf12n41hzai8n936wxb3vb3r0"))))
      (build-system cargo-build-system)
      (native-inputs (list tar bzip2))
      ;; (arguments
      ;;  )
      (home-page "https://github.com/phisch/phinger-cursors")
      (synopsis "Most likely the most over engineered cursor theme out there")
      (description
       "Say hello to your new cursor theme. Phinger cursors is most likely the most over engineered cursor theme out there.")
      (license license:cc-by-sa4.0))))

zola
